/*
 *            <<< Ђ݂Book >>>
 *
 *      High Speed Text Viewer for FM-TOWNS
 *
 *  presented by MIYAZAKI & sugi  1990,91,92,93
*/

#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>
#include    <ctype.h>
#include    <egb.h>
#include    <mos.h>
#include    <fmc.h>
#include    <msdos.cf>
#include    <system.cf>
#include    "menu_evt.h"
#include    "init.h"
#include    "book.h"
#include    "lib.h"
#include    "doslib.h"
#include    "snd.h"
#include    "keyio.h"
#include    "cons.h"
#include    "mouse.h"
#ifdef VSYNC
# include   "vsync.h"
#endif


/*  Ot@Cɂ郋[`  */
extern  void    dsp_main(char *file);   /*  eLXg\̃C  */
extern  void    set_vector(void);       /*  n[hG[xN^̐ݒ  */
extern  void    reset_vector(void);     /*  n[hG[xN^̕A  */

extern  char   *param(char *path);      /*  p[^̃fBNgɈړ  */

static  char   moswork[MosWorkSize];    /*  mouseCup  */
static  char   sndwork[SndWorkSize];    /*  snd  Cup  */
        char   *config  = NULL;         /*  BOOK.CFG  */

const   cct[] =     /*  Fe[u  */
{
    0x00000000, 0x11111111, 0x22222222, 0x33333333,
    0x44444444, 0x55555555, 0x66666666, 0x77777777,
    0x88888888, 0x99999999, 0xAAAAAAAA, 0xBBBBBBBB,
    0xCCCCCCCC, 0xDDDDDDDD, 0xEEEEEEEE, 0xFFFFFFFF
};

void    _mwcall_onexit_fcns(void)
{
    /*  atexit() gȂ  */
}


int     main(int argc, char *argv[])
{
int     i;
char    *file = NULL;
char    *p;
char    crrdir[256];

    /*  p[^ƃIvV̉  */
    for (i = 1; i < argc; i++)
    {
        p = argv[i] ;

        if (*p == '/' || *p == '-')
        {
            p++;
            switch (toupper(*p))
            {
              case 'C':         /*  BOOK.CFG ̈ʒu  */
                if (*(p+1) != '\0')
                    config = p+1;
                goto next;

              case 'V':         /*  version  */
                _strcats(80, crrdir, "book.exp v",
                        _version, " / ", date, " / ", timestamp, "\n", NULL);
                write(1, crrdir, strlen(crrdir));
                exit(0);
            }
        }
        else
            file = p;
next:   continue;
    }

    /*  vIG[荞݂̍Đݒ  */
    set_vector();

    /*  BOOK.EXP ̃pXXg쐬  */
    strcpy(crrdir, argv[0]);
    if ((p = jstrrchr(crrdir, '\\')) == NULL &&
        (p = strchr(crrdir, ':')) == NULL)
        crrdir[0] = '\0';
    else
        *++p = '\0';

    /*  RtBOt@Cǂ  */
    if (config == NULL &&
        (config = (char *)malloc( strlen(crrdir) + 16)) != NULL)
    {
        strcpy(config, crrdir);
        strcat(config, CONFIG_FILE);
    }
    if (config != NULL)
        configuration(config);

    /*  w肳ĂȂꍇ onsei.dic ̃tpX쐬  */
    if (setup.onsei_dic == NULL &&
        (setup.onsei_dic = (char *)malloc(strlen(crrdir) + 16)) != NULL)
    {
        strcpy(setup.onsei_dic, crrdir);
        strcat(setup.onsei_dic, ONSEI_DIC);
    }

    /*  ÑJgEfBNgޔ  */
    getdir(crrdir);
    if ((p = jstrrchr(crrdir, '\\')) != NULL && strlen(crrdir) > 3)
        *p = '\0';      /*  ]v \ Ԃ  */
    chdrv(*crrdir - 'A');

    /*  IvVɂt@Cw͓ʏ  */
    if ((p = param(file)) != NULL)
        file = p;

    /*  ʂ̏  */
    EGB_init(gwork, EgbWorkSize);

    setup.palette.text2 = setup.palette.text;
    setup.palette.text2.color = 2;
    init_screen();

#ifdef VSYNC
    /* urxmb荞݃Cȕ */
    VSYNC_init();
#endif
    SND_init(sndwork);
    SND_elevol_mute(0x33);

    /*  }EX̏  */
    MOS_start(moswork, MosWorkSize);
    MOS_resolution(0, 3);
    MOS_resolution(1, 3);
    MOS_writePage(1);
    MOS_horizon(MIN_HORIZON, (max_horizon = MAX_HORIZON2));
    MOS_vertical(MIN_VERTICAL, MAX_VERTICAL);

    mos_ptn_init();
    set_mos_ptn(MOSCSR_FINGER);
    MOS_disp(MOS_ON);

    ctblset(_CHR_COL, _BAK_COL);

#ifdef VSYNC
#else
    /*  FM荞݂̏  */
    SND_fm_timer_a_set(0, 1);
#endif

    /*  L[{[hATC̕ۑ  */
    kb_asign_push();

    /*  L[AhXϊe[ȕ  */
    kb_setup_cnvtbl();

    /*  Ȋϊgp錾  */
    KAN_start();

    /*  ONSEI.DIC ̓ǂݍ  */
    if (init_tree(setup.onsei_dic) != ERR)
        can_use_snd = TRUE;

    /*  Main Loop Ă  */
    dsp_main(file);

    /*  ʃTCY̍Đݒ  */
    wide_screen(OFF);
    vertical_screen(480);

    /*  ȊϊI錾  */
    KAN_end();

    /*  L[{[hATC̕  */
    kb_asign_pop();

    /*  }EXƃTEh̏I錾  */
    MOS_end();
    SND_elevol_mute(0x00);
    SND_end();

#ifdef VSYNC
    /* urxmb荞݃CȕI */
    VSYNC_end();
#else
    /*  FM荞݂̏I  */
    SND_fm_timer_a_set(0, 1);
#endif

    /*  ÑJgEfBNg֕A  */
    chdrv(crrdir[0] - 'A');
    chdir(crrdir);

    /*  vIG[荞݂̍Đݒ  */
    reset_vector();

    return 0;
}



